%{
open ast
open tab
open ops
%}
%token CARD COMA PCOMA PI PD ASTER
%token FROM SELECT WHERE
%token AND NOT OR
%token MENOR MENIG IGUAL MAYIG MAYOR DIST

%token<int> ENT
%token<string> ID TEXTO

%type<ast.Tabla> query
%type<int> atr
%type<int list> listaAtrs
%type<ast.Tabla list> listaTablas
%type<ast.Tabla -> ast.Tabla> seccWhere
%type<ast.Tupla -> bool> cond
%type<ast.Tupla -> ast.Atrib> expr

%left OR
%left AND
%right NOT

%nonassoc MENOR MENIG IGUAL MAYIG MAYOR DIST

%start query

%%
query: SELECT listaAtrs FROM listaTablas seccWhere PCOMA
                                { proy($2, $5(prodN $4)) }

        | SELECT ASTER FROM listaTablas seccWhere PCOMA
                                { $5(prodN $4) }

listaAtrs: atr                  { [$1] }
        | atr COMA listaAtrs    { $1::$3 }

atr: CARD ENT                   { $2 }

listaTablas: ID                 { [tabla $1] }
        | ID COMA listaTablas   { tabla($1)::$3 }

seccWhere: WHERE cond           { List.filter $2 }
        |                       { fn x => x }

cond: expr MENOR expr           { Menor $1 $3 }
        | expr MENIG expr       { MenIg $1 $3 }
        | expr IGUAL expr       { Igual $1 $3 }
        | expr MAYIG expr       { MayIg $1 $3 }
        | expr MAYOR expr       { Mayor $1 $3 }
        | expr DIST expr        { Dist $1 $3 }

        | PI cond PD            { $2 }
        | cond AND cond         { And $1 $3 }
        | cond OR cond          { Or $1 $3 }
        | NOT cond              { Not $2 }
        
expr: atr                       { Atr $1 }
        | ENT                   { Cte(Nro $1) }
        | TEXTO                 { Cte(Txt $1) }

%%

