{
open grm
exception noEsta
val palClaves = Polyhash.mkPolyTable(19, noEsta)
val _ = List.app (fn x => Polyhash.insert palClaves x)
                        [("and",                         AND),
                         ("from",                        FROM),
                         ("not",                         NOT),
                         ("or",                          OR),
                         ("select",                      SELECT),
                         ("where",                       WHERE)]
fun idOPalClave s =
        case Polyhash.peek palClaves s of
        SOME v => v
        | NONE => ID s
val atoi = valOf o Int.fromString
}

rule Tok =
        parse 
    [` ``\t``\n`]+          { Tok lexbuf }
    | "#"                           { CARD }
    | "<>"                          { DIST }
    | "="                           { IGUAL }
    | ">="                          { MAYIG }
    | ">"                           { MAYOR }
    | "<="                          { MENIG }
    | "<"                           { MENOR }
    | "*"                           { ASTER }
    | ","                           { COMA }
    | ";"                           { PCOMA }
    | ")"                           { PD }
    | "("                           { PI }
    | `0`|[`1`-`9`][`0`-`9`]*               { ENT(atoi(getLexeme lexbuf)) }
    | [`A`-`Z``a`-`z`][`A`-`Z``a`-`z``_``0`-`9`]+
                                                    { idOPalClave(getLexeme lexbuf) }
    | `"`                           { TEXTO(String lexbuf) }
    | _                                     { raise Fail("caracter ["^
                                                                            getLexeme(lexbuf)^"] raro!") }
and String =
        parse 
    eof                                     { raise Fail "EOF en string!" }
    | `\n`                          { raise Fail "string incompleta!" }
    | "\\\""                        { "\""^String(lexbuf) }
    | `"`                           { "" }
    | [` `-`z`]                     { getLexeme(lexbuf)^String(lexbuf) }
    | _                                     { raise Fail "caracter desconocido!" }
        ;
