open ast

fun Atr n l = List.nth(l, n)

fun Cte c _ = c

fun And p1 p2 x = p1(x) andalso p2(x)
fun Or p1 p2 x = p1(x) orelse p2(x)
fun Not p x = not(p x)

fun Igual m n x =
        case (m x, n x) of
        (Nro i, Nro j) => i=j
        | (Txt i, Txt j) => i=j
        | _ => raise Fail "error: tipos distintos"
fun Menor m n x =
        case (m x, n x) of
        (Nro i, Nro j) => i<j
        | (Txt i, Txt j) => i<j
        | _ => raise Fail "error: tipos distintos"
fun MenIg m n = (Or (Igual m n) (Menor m n))
fun Mayor m n = Not(Or (Igual m n) (Menor m n))
fun MayIg m n = Not(Menor m n)
fun Dist m n = Not(Igual m n)


fun proy(li, tabla) =
    let fun aux l = List.map (fn x => List.nth(l, x)) li

    in  map aux tabla end

fun prodCart(x, []) = x
| prodCart([], y) = y
| prodCart(x, y) =
        let     fun cartB _ [] = []
                | cartB x (h::t) = (x@h)::(cartB x t)
                fun cartA [] _ = []
                | cartA (h::t) l = (cartB h l)@(cartA t l)
        in      cartA x y end


fun prodN l = List.foldr prodCart [] l

