(*
        Interprete para SQL.
*)

open BasicIO Nonstdio
open ast
open ops

fun printTabla t =
        let     fun atrStr(Nro n) = Int.toString(n)
                | atrStr(Txt s) = s

                fun mapAtrStr t = map (fn x => map atrStr x) t

                fun printLStr l = (List.app (fn x => print(x^" ")) l; print "\n")

                val t' = mapAtrStr t
        in      List.app printLStr t' end

fun createLexerStream (is : instream) =
        Lexing.createLexer (fn buff =>
                fn n => Nonstdio.buff_input is buff 0 n)

val _ =
        let     val entr = open_in(hd(CommandLine.arguments()))
                                handle _ => (print "usando std_in\n"; std_in)
                val lexbuf = createLexerStream entr
                val result = grm.query lex.Tok lexbuf
        in
                print "Respuesta:\n";
                printTabla result
        end
        handle Fail s => print(s^"\n")
        | _ => print "Aughh!\n"


